# Makefile for C version of ELEFUNT package using Turbo C 2.0 on IBM PC
# [26-Nov-88]

CC = tcc

# NB: If your C compiler implements double and float in
# different hardware precisions, the tests MUST be carried out
# in pure double; mixed float and double will give incorrect results.

CFLAGS= -Dfloat=double -DIEEE=1 -f87 -k -N -y -M -A

L = .tcc

O = .obj

X = .exe

ELIB = elib.lib

OBJS =	machar$(O) ran$(O) randl$(O) store$(O) ipow$(O) mather$(O)

.c.obj:;	$(CC) -c $(CFLAGS) $* >$*.clg
		terrshow <$*.clg >$*.cer
		del $*.clg

RM = del

all:	tsmach \
	talog tasin tatan texp tpower tsin tsinh tsqrt ttan ttanh

tsmach:	tsmach$(X)
	tsmach >tsmach$(L)

talog:	talog$(X)
	talog >talog$(L)

tasin:	tasin$(X)
	tasin >tasin$(L)

tatan:	tatan$(X)
	tatan >tatan$(L)

texp:	texp$(X)
	texp >texp$(L)

tpower:	tpower$(X)
	tpower >tpower$(L)

tsin:	tsin$(X)
	tsin >tsin$(L)

tsinh:	tsinh$(X)
	tsinh >tsinh$(L)

tsqrt:	tsqrt$(X)
	tsqrt >tsqrt$(L)

ttan:	ttan$(X)
	ttan >ttan$(L)

ttanh:	ttanh$(X)
	ttanh >ttanh$(L)

clean:
	$(RM) *$(O)
	$(RM) talog$(X)
	$(RM) tasin$(X)
	$(RM) tatan$(X)
	$(RM) texp$(X)
	$(RM) tpower$(X)
	$(RM) tsin$(X)
	$(RM) tsinh$(X)
	$(RM) tsqrt$(X)
	$(RM) ttan$(X)
	$(RM) ttanh$(X)
	$(RM) tsmach$(X)

$(ELIB):	$(OBJS)
	$(RM) $(ELIB)
	tlib $(ELIB) +machar$(O) +ran$(O) +randl$(O) +store$(O) +ipow$(O) +mather$(O)

foo:	foo$(X)

foo$(X):	mexp$(O) foo$(O) $(ELIB)
	$(CC) $(CFLAGS) -efoo$(X) mexp$(O) foo$(O) $(ELIB)

tsmach$(X):	tsmach$(O) machar$(O) store$(O)
	$(CC) $(CFLAGS) -etsmach$(X) tsmach$(O) $(ELIB)

talog$(X):	malog$(O) talog$(O) $(ELIB)
	$(CC) $(CFLAGS) -etalog$(X) malog$(O) talog$(O) $(ELIB)

tasin$(X):	masin$(O) tasin$(O) $(ELIB)
	$(CC) $(CFLAGS) -etasin$(X) masin$(O) tasin$(O) $(ELIB)

tatan$(X):	matan$(O) tatan$(O) $(ELIB)
	$(CC) $(CFLAGS) -etatan$(X) matan$(O) tatan$(O) $(ELIB)

texp$(X):	mexp$(O) texp$(O) $(ELIB)
	$(CC) $(CFLAGS) -etexp$(X) mexp$(O) texp$(O) $(ELIB)

tpower$(X):	mpower$(O) tpower$(O) $(ELIB)
	$(CC) $(CFLAGS) -etpower$(X) mpower$(O) tpower$(O) $(ELIB)

tsin$(X):	msin$(O) tsin$(O) $(ELIB)
	$(CC) $(CFLAGS) -etsin$(X) msin$(O) tsin$(O) $(ELIB)

tsinh$(X):	msinh$(O) tsinh$(O) $(ELIB)
	$(CC) $(CFLAGS) -etsinh$(X) msinh$(O) tsinh$(O) $(ELIB)

tsqrt$(X):	msqrt$(O) tsqrt$(O) $(ELIB)
	$(CC) $(CFLAGS) -etsqrt$(X) msqrt$(O) tsqrt$(O) $(ELIB)

ttan$(X):	mtan$(O) ttan$(O) $(ELIB)
	$(CC) $(CFLAGS) -ettan$(X) mtan$(O) ttan$(O) $(ELIB)

ttanh$(X):	mtanh$(O) ttanh$(O) $(ELIB)
	$(CC) $(CFLAGS) -ettanh$(X) mtanh$(O) ttanh$(O) $(ELIB)

# mather cannot be compiled with -A -- math.h doesn't include defs of
# the flags DOMAIN et al when __STDC__ is defined.
mather$(O):	mather.c
	 $(CC) -Dfloat=double -DIEEE=1 -f87 -k -N -y -M -c mather.c